<?php

// SphereGate for RICOH THETA
// Written by moyashi http://hitoriblog.com/

// ------------------------------
// User Define
// ------------------------------

	define('MY_HOST', 'http://hitoriblog.com/');

// ------------------------------

	require __DIR__.'/goutte.phar';
	use Goutte\Client;

	define('TEMPLATE_HTML5', './template_html5.html');
	define('TEMPLATE_FLASH', './template_flash.html');
	define('USER_AGENT_IPHONE', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_0 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11A465 Safari/9537.53');
	define('ERROR_TEMPLATE', '<!DOCTYPE html>
<html class="mobile">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <title>RICOH THETA</title>
  </head>
  <body>
  <p>_MESSAGE_</p>
  </body>
</html>');

	function mes($message) {
		print str_replace("_MESSAGE_", $message, ERROR_TEMPLATE);
	}

	function isSmartDevice($useragent) {
		if ((strpos($useragent, 'iPhone') !== false) ||
			(strpos($useragent, 'iPod') !== false) ||
			(strpos($useragent, 'iPad') !== false) ||
			(strpos($useragent, 'Android') !== false)) {
			return true;
		} else {
			return false;
		}
	}

	function putsHTML5Page($url) {
		$client = new Client();
		$client->setHeader('User-Agent', USER_AGENT_IPHONE);
		$crawler = $client->request('GET', $url);
	
		//print $client->getResponse()->getContent();
	
		$images = $crawler->filter('#cube img')->extract(array('src'));
	
		if (count($images) == 7) {
			if (file_exists(TEMPLATE_HTML5)) {
				$template = file_get_contents(TEMPLATE_HTML5);
				for ($i = 0; $i < count($images); $i++) {
					$template = str_replace("_img" . $i . "_", $images[$i], $template);
				}
				print $template;
			} else {
				mes("Template ".TEMPLATE_HTML5." not found.");
			}
		} else {
			mes("Images not found.");
		}
	}

	function putsFlashPage($url) {
		$client = new Client();
		$crawler = $client->request('GET', $url);
	
		//print $client->getResponse()->getContent();
	
		$images = $crawler->filter('#urlText')->extract(array('value'));
		if (count($images) == 1) {
			if (file_exists(TEMPLATE_FLASH)) {
				$template = file_get_contents(TEMPLATE_FLASH);
				for ($i = 0; $i < count($images); $i++) {
					$template = str_replace("_img" . $i . "_", $images[$i], $template);
				}
				print $template;
			} else {
				mes("Template ".TEMPLATE_FLASH." not found.");
			}
		} else {
			mes("Images not found.");
		}
	}

	function main() {
		$url = $_GET["url"];
		$referer = $_SERVER["HTTP_REFERER"];
	
		if ($referer != NULL && strpos($referer, MY_HOST) <= 0) {
			if (preg_match('/^https:\/\/theta360\.com\/spheres\/.+|^https:\/\/theta360\.com\/[a-z]\/[0-9a-zA-Z]+/', $url)) {
				if (isSmartDevice($_SERVER['HTTP_USER_AGENT'])) {
					putsHTML5Page($url);
				} else {
					putsFlashPage($url);
				}
			} else {
				mes("Specified url \"".$url."\" is invalid.");
			}
		} else {
			mes("Access denied for host: \"".$referer."\".");
			return;		
		}
	}

	main();
	
?>
